////////////////////////////////////////////////////////////////////////////////
// StreamRecorder.h
// Mario Chirinos
// 2014-02-12
//------------------------------------------------------------------------------
// Notes:
//	Streaming recorder with GStreamer
//
////////////////////////////////////////////////////////////////////////////////

#ifndef STREAMRECORDER_H
#define STREAMRECORDER_H

// your public header include
//------------------------------------------------------------------------------
#include <gst/gst.h>
//------------------------------------------------------------------------------
#define STREAMRECORDER_SAMPLERATE 44100
#define READSIZE 1152 //For MPEG1, frame_size = 1152 samples/frame
#define STREAMRECORDER_BYTESPERSAMPLE 2
// the declaration of your class...
//------------------------------------------------------------------------------
class StreamRecorder
{
 private:
	unsigned int nBytes;
	unsigned int bufferSize;
	unsigned char* audioBuffer;
	unsigned char* audioBufferPosition;
	int recordTime;
	char* sourceName;
	GstElement* streamSrc;
	GstElement* audioConvert;
	GstElement* audioResample;
        GstElement* filterCaps;
	GstElement* queue0;
	GstElement* queue1;
	GstElement* filter;
//	GstElement* compressor;
//	GstElement* queue2;
//	GstElement* muxer;
//        GstElement* fileSink; 
        GstElement* fakeSink; 
        GstElement* audioSink;            
	GstElement* mainPipeline;
//	GstElement* sinkPipeline;

        GstElement* tempBin;       

	int createMainPipeline();
//	int createSinkPipeline();
	int connect(const char *uri);
	int disconnect();
	static void srcNewPad_callback(GstElement *element, GstPad *pad, void *data);
	static int bus_callback(GstBus *bus, GstMessage *message, void *data);
//	static void block_async_cb (GstPad * pad, gboolean blocked, gpointer user_data);
	static void buffer_callback(GstElement *fakesink, GstBuffer *buffer, GstPad *pad, gpointer user_data);
	static int filter_handoff_callback(GstElement* filter, GstBuffer* buffer, void* user_data);
	int addToBuffer(unsigned char* data, int length);
	int compressBuffer();
	int saveWav(unsigned char* data, int size) const;
	void printCaps(GstPad *pad);
 public:
	StreamRecorder(const char* source, int time);
};
//------------------------------------------------------------------------------
#endif
